// components/scan..js
import { connectStateMap, connectStateTypes } from '../../data/devType.js'
Component({
    /**
     * 组件的属性列表
     */
    properties: {
        state: {
            type: Number,
            value: connectStateTypes.unConnect
        },
        devName: {
            type: String,
            value: ""
        }
    },
    
    /**
     * 组件的初始数据
     */
    data: {
        // 连接状态
        connectStateMap: connectStateMap,
        connectStateTypes: connectStateTypes
    },
    
    /**
     * 组件的方法列表
     */
    methods: {
        searchDevice(){
            // 触发父组件的事件
            this.triggerEvent('searchDevice')
        },
        disconnectDevice(){
            // 触发父组件的事件
            this.triggerEvent('disconnectDevice')
        }
    }
})