// pages/index/index.js
import { loadSonyItem } from '../../api/sony.js'
import { handle } from '../../utils/handle.js'
Page({

  /**
   * 页面的初始数据
   */
  data: {
    sonyItems: []
  },

  openPageHandle(e){
    let cmd = e.currentTarget.dataset.dev;
    console.log(e);
    console.log(cmd);
    switch(cmd){
      case 'light':
        wx.switchTab({
          url: '/pages/light/light',
        })
        break;
      case 'camera':
          wx.switchTab({
            url: '/pages/old/index',
          })
          break;
      case 'bleTool':
        wx.navigateTo({
          url: '/pages/ble/ble',
        })
        break;
      default:
        wx.showToast({
          title: '该页面正在开发中',
        })
        break;
    }
  },
  /**
   * 生命周期函数--监听页面加载
   */
  async onLoad(options) {
    // 获取索尼功能实现清单
    let err,sonyItems;
    [err,sonyItems] = await loadSonyItem()
    if(err){
      console.log(err)
      return
    }
    console.log(sonyItems)
    this.setData({
      sonyItems: sonyItems
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {
    
  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    // 配置导航栏
    wx.setNavigationBarTitle({
      title: '蓝牙工具箱'
    })
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  },

  toPage(e){
    // 获取页面路径
    let url = e.currentTarget.dataset.url
    if(!url){
      return
    }
    wx.navigateTo({
      url: url
    })
  }
})