class t {
  ms = 0;
  timer = null;
  startTimer = null;
  isPause = false;
  reFreshTime = 10;// 更新数据毫秒
  lastTime = 0;// 上一次的毫秒数
  countdownTime = null; // 倒计时总时间
  scheduledTasks = []; // 计划的任务
  constructor(countdownTime){
    this.ms = 0;
    this.timer = null;
    this.countdownTime = countdownTime;
  }
  init(){
    this.ms = 0;
    if(this.timer){
      clearTimeout(this.timer);
    }
  }
  start(){
    // 开始第一步 10ms 更新一次数值
    let date = new Date();
    this.startTimer = date.getTime();
    this.lastTime = date.getTime();
    if(this.isPause){
      // 从暂停中恢复
    }else{
      // 新的数据
      this.ms = 0;
    }
    console.log('开始计时器');
    this.isPause = false;
    this.tick();
  }
  pause(){
    // 暂存当前经过的时间
    this.isPause = true;
    // 中止time
    clearTimeout(this.timer);
    this.timer = null;
  }
  stop(){
    console.log('停止计时');
    clearTimeout(this.timer);
    this.timer = null;
    this.isPause = false;
  }
  addCountdownTask(duration, callback) {
    const endTime = new Date().getTime() + duration;
    this.countdownTasks.push({ endTime, callback });
  }
  /** 
  添加计划任务
  */
  addScheduledTask(hour, minute, second, callback, skipDays = 0) {
    const newTask = { hour, minute, second, callback, skipDays };
    const index = this.scheduledTasks.findIndex(
      (task) =>
        task.hour > newTask.hour ||
        (task.hour === newTask.hour && task.minute > newTask.minute) ||
        (task.hour === newTask.hour &&
          task.minute === newTask.minute &&
          task.second > newTask.second)
    );
    if (index === -1) {
      this.scheduledTasks.push(newTask);
    } else {
      this.scheduledTasks.splice(index, 0, newTask);
    }
  }
  // 修改计划任务的时间
  updateScheduledTask(index, hour, minute, second) {
    if (this.scheduledTasks[index]) {
      this.scheduledTasks[index].hour = hour;
      this.scheduledTasks[index].minute = minute;
      this.scheduledTasks[index].second = second;
    }
  }
   // 跳过明天
  skipTomorrow(index) {
    if (this.scheduledTasks[index]) {
      this.scheduledTasks[index].skipDays = 1;
    }
  }
  tick(){
    let latencyTime = this.reFreshTime;
    // 获取当前时间,以及上一次时间
    let date = new Date();
    let nowTimeStamp = date.getTime();
    let lastTime = this.lastTime;
    // 两次执行间的时间差
    let timeGap = nowTimeStamp - lastTime;
    if((timeGap - this.reFreshTime) < 0){
    latencyTime = this.reFreshTime + (timeGap - this.reFreshTime) ;
    }else {
    latencyTime = this.reFreshTime - (timeGap - this.reFreshTime) ;
    latencyTime = Math.max(latencyTime,0);
    }
    if(this.isPause){
      console.log('已经暂停');
      return false;
    }
    this.ms += timeGap;
    this.lastTime = nowTimeStamp;
    // 检查计划任务
    const currentTime = new Date();
    this.countdownTasks = this.countdownTasks.filter((task) => {
      if (currentTime >= task.endTime) {
        task.callback();
        return false;
      }
      return true;
    });
    this.scheduledTasks.forEach((task, index) => {
      if (
        currentTime.getHours() === task.hour &&
        currentTime.getMinutes() === task.minute &&
        currentTime.getSeconds() === task.second
      ) {
        if (task.skipDays > 0) {
          task.skipDays--; // 减少跳过的天数
        } else {
          // 1 分钟提醒
          if (currentTime.getMinutes() === task.minute - 1) {
            console.log(`任务 ${index} 将在 1 分钟后执行`);
          }
          task.callback();
        }
      }
    });
    
     
    // 触发hook
    this._reFreshHook(this.ms);
    this.timer = setTimeout(()=>{
      this.tick();
    },latencyTime);
    return true;
  }
  parse(msNum){
    // 60:60:100
    let time_minute =  Math.floor(msNum/1000/60);
    let time_second = Math.floor((msNum/1000)%60);
    let time_ms = msNum%1000;
    return {
      minute:time_minute,
      second: time_second,
      ms: time_ms,
      toString(){
        return `${time_minute}:${time_second}:${time_ms}`
      }
    }
  }
  setHook(_reFreshHook){
    this._reFreshHook = _reFreshHook;
  }
  _reFreshHook(){

  }
}

module.exports = t;